version: '3'

services:
  eureka-service:
    build: eureka-service/
    container_name: eureka-server
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8761:8761
      
  config-service:
    build: config-service/
    container_name: config-server
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8009:8009
            
  api-gateway:
    build: api-gateway-service/
    container_name: api-gateway-service
    depends_on:
      - config-service
      - eureka-service      
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8080:8080
      
  mongo:
    image: mongo
    container_name: mongo
    restart: always
    ports:
      - 27017:27017
    network_mode: host
    
  mysql:
    image: mysql
    ports:
      - 3306:3306
    container_name: mysql
    environment:
      MYSQL_ROOT_PASSWORD: root
      MYSQL_DATABASE: usersdb
      MYSQL_PASSWORD: root
      MYSQL_USER: root
      MYSQL_ALLOW_EMPTY_PASSWORD: "yes"    
    network_mode: "host"
    hostname: localhost
    restart: always
    
  rabbitmq:
    image: rabbitmq:3-management
    container_name: rabbitmq
    restart: always
    ports:
      - 5672:5672
      - 15672:15672
    hostname: localhost
        
  customer-service:
    build: customer-service/
    container_name: customer-service
    depends_on:
      - config-service
      - eureka-service
      - rabbitmq
      - mongo      
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8003:8003
  
  loan-service:
    build: loan-service/
    container_name: loan-service
    depends_on:
      - config-service
      - eureka-service
      - rabbitmq
      - mongo
      - customer-service      
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8004:8004
      
  authentication-service:
    build: authentication-service/
    container_name: authentication-service
    depends_on:
      - config-service
      - eureka-service
      - rabbitmq
      - mysql
      - customer-service      
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8005:8005
      
      
  front-end:
    build: front-end/
    container_name: front-end        
    restart: always
    network_mode: "host"
    hostname: localhost
    ports:
      - 8080:8080
      
    